<template>
    <v-col cols="auto">
        <v-dialog v-model="warning" transition="dialog-top-transition" max-width="275">
            <template v-slot:default>
                <v-card rounded="xl">
                    <div class="pb-5 text-center">
                        <v-icon class="my-6" color="warning" icon="mdi-alert-circle" size="128"></v-icon>
                        <div class="t-text">ไม่สามารถลบอุปกรณ์ได้</div>
                    </div>
                </v-card>
            </template>
        </v-dialog>
    </v-col>

    <v-data-iterator v-if="equipmentsRef" :items="equipmentsRef" :items-per-page="20" :search="search">
        <template v-slot:header>
            <v-toolbar class="px-2">
                <v-text-field v-model="search" clearable density="compact" hide-details placeholder="Search"
                    prepend-inner-icon="mdi-magnify" style="max-width: 800px" variant="solo" rounded="xl"
                    class="mx-auto px-1"></v-text-field>
            </v-toolbar>
        </template>

        <template v-slot:default="{ items }">
            <div class="container">
                <div class="incontainer">
                    <v-dialog transition="dialog-top-transition" max-width=400px>
                        <template v-if="loaded" v-slot:activator="{ props }">
                            <div v-bind="props" class="card d-flex flex-column">
                                <div class="add-card d-flex justify-center align-center">
                                    <v-icon icon="mdi-plus" size="60" color="grey" />
                                </div>
                            </div>
                        </template>
                        <template v-slot:default="{ isActive }">
                            <v-card rounded="xl">
                                <v-form @submit.prevent="onAddEquipment">
                                    <v-toolbar color=#fcc200 title="เพิ่มอุปกรณ์" class="align-text-center">
                                        <v-btn @click="isActive.value = false" icon="mdi-close" />
                                    </v-toolbar>
                                    <v-card-text class="pb-0 px-6">
                                        <v-file-input v-model="image" label="รูปภาพ" prepend-icon="mdi-image"
                                            variant="outlined" density="compact" rounded="xl"></v-file-input>
                                        <v-text-field v-model="equipmentName" :rules="[equipmentNameRules.required]"
                                            variant="outlined" density="compact" rounded="xl"
                                            label="ชื่ออุปกรณ์"></v-text-field>
                                        <v-text-field v-model="equipmentQuantity"
                                            :rules="[equipmentQuantityRules.required]" variant="outlined"
                                            density="compact" rounded="xl" label="จำนวน" type="number"
                                            placeholder="จำนวนอุปกรณ์"></v-text-field>
                                        <v-text-field v-model="dayLimit" variant="outlined"
                                            :rules="[equipmentDayLimitRules.required]" density="compact" rounded="xl"
                                            label="ระยะเวลาในการยืม" type="number"
                                            placeholder="จำนวนวัน"></v-text-field>
                                        <v-text-field v-model="equipmentDetail" variant="outlined" density="compact"
                                            rounded="xl" label="รายละเอียดอุปกรณ์"
                                            placeholder="ไม่บังคับ"></v-text-field>
                                    </v-card-text>

                                    <v-card-actions class="justify-space-evenly pt-0">
                                        <v-btn variant="text" @click="() => { onCancel(); isActive.value = false; }"
                                            rounded="xl">ยกเลิก</v-btn>
                                        <v-btn variant="text" type="submit" color="amber-darken-1" rounded="xl"
                                            @click="isActive.value = false" :disabled="!isFormValid">บันทึก
                                        </v-btn>
                                    </v-card-actions>
                                </v-form>
                            </v-card>
                        </template>
                    </v-dialog>

                    <v-dialog transition="dialog-top-transition" max-width=400px>
                        <template v-if="loaded" v-slot:activator="{ props }">
                            <div v-bind="props" class="card d-flex flex-column" v-for="equipment in items"
                                :key="equipment.id" :class="{ 'bg-gray': equipment.raw.quantity < 1 }"
                                @click="openDialog(equipment)">
                                <v-img v-if="equipment.raw.image" :src="media + equipment.raw.image[0].url"
                                    :aspect-ratio="1"
                                    :style="{ filter: equipment.raw.quantity < 1 ? 'brightness(92%)' : 'brightness(100%)',boxShadow: '0 2px 2px rgba(0, 0, 0, 0)' }"
                                    width="150" class="img" cover />
                                <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="150"
                                    class="img" cover />
                                <p class="pa-1 mb-auto">{{ equipment.raw.name }}</p>

                                <div class="mt-auto">
                                    <p class="pa-1 text-detail">{{ equipment.raw.provider_name }}</p>
                                    <div class="d-flex text-detail">
                                        <span class="text-orange-darken-3">ระยะเวลา: {{ equipment.raw.day_limit }}
                                            วัน</span>
                                        <span v-if="equipment.raw.quantity >= 1" class="text-grey-darken-1">เหลือ {{
                                            equipment.raw.quantity }}</span>
                                        <span v-else class="text-grey-darken-1 mr-2">หมดแล้ว</span>
                                    </div>
                                </div>
                            </div>
                        </template>

                        <template v-slot:default="{ isActive }">
                            <v-card rounded="xl">
                                <v-form @submit.prevent="onEditEquipment">
                                    <v-toolbar color=#fcc200 title="แก้ไขข้อมูล" class="align-text-center">
                                        <v-btn @click="isActive.value = false" icon="mdi-close" />
                                    </v-toolbar>
                                    <v-card-text class="pb-0 px-6">
                                        <v-file-input v-model="editEquipmentImage" label="รูปภาพ"
                                            prepend-icon="mdi-image" variant="outlined" density="compact"
                                            rounded="xl"></v-file-input>
                                        <v-text-field v-model="editEquipmentName" :rules="[equipmentNameRules.required]"
                                            variant="outlined" density="compact" rounded="xl"
                                            label="ชื่ออุปกรณ์"></v-text-field>
                                        <v-text-field v-model="editEquipmentQuantity"
                                            :rules="[equipmentQuantityRules.required]" variant="outlined"
                                            density="compact" rounded="xl" label="จำนวน" type="number"></v-text-field>
                                        <v-text-field v-model="editEquipmentDayLimit"
                                            :rules="[equipmentDayLimitRules.required]" variant="outlined"
                                            density="compact" rounded="xl" label="ระยะเวลาในการยืม"></v-text-field>
                                        <v-text-field v-model="editEquipmentDetail" variant="outlined" density="compact"
                                            rounded="xl" label="รายละเอียดอุปกรณ์"></v-text-field>
                                    </v-card-text>

                                    <v-card-actions class="justify-space-between pt-0 px-6">
                                        <v-btn variant="text" width="100"
                                            @click="() => { onDeleteEquipment(); isActive.value = false; }"
                                            rounded="xl">ลบอุปกรณ์</v-btn>
                                        <nuxt-link :to="`/borrower/${editEquipmentId}`" class="link">
                                            <v-btn variant="text" width="100" rounded="xl">ผู้ยืมปัจจุบัน</v-btn>
                                        </nuxt-link>
                                        <v-btn variant="outlined" type="submit" color="amber-darken-1" rounded="xl"
                                            width="100" @click="isActive.value = false"
                                            :disabled="!isEditFormValid">บันทึก</v-btn>
                                    </v-card-actions>
                                </v-form>
                            </v-card>
                        </template>
                    </v-dialog>
                </div>
            </div>
        </template>

        <template v-slot:footer="{ page, pageCount, prevPage, nextPage }">
            <div class="d-flex align-center justify-center pa-4">
                <v-btn :disabled="page === 1" icon="mdi-arrow-left" density="comfortable" variant="tonal" rounded
                    @click="prevPage"></v-btn>

                <div class="mx-2 text-caption">Page {{ page }} of {{ pageCount }}</div>

                <v-btn :disabled="page >= pageCount" icon="mdi-arrow-right" density="comfortable" variant="tonal"
                    rounded @click="nextPage"></v-btn>
            </div>
        </template>
    </v-data-iterator>

    <div v-else>
        <div class="container">
            <div class="incontainer">
                <v-skeleton-loader v-for="i in 10" :key="i" class="mx-auto border skeleton-loader" width="150"
                    type="image, article"></v-skeleton-loader>
            </div>
        </div>
    </div>
</template>

<script setup>
useHead({
    title: "ระบบยืม-คืน | จัดการอุปกรณ์",
    meta: [{ name: "description", content: "การจัดการอุปกรณ์" }],
});
definePageMeta({
    middleware: "admin",
});
import { ref, onMounted } from 'vue'
import axios from 'axios'

const token = useStrapiToken();
const url = useStrapiUrl();
const media = useStrapiMedia();

const equipments = ref([])
const search = ref('')
const equipmentsRef = ref()

const image = ref([])
const equipmentName = ref()
const equipmentQuantity = ref()
const equipmentDetail = ref()
const dayLimit = ref()

const loaded = ref(false)
const warning = ref(false)

const selectedEquipment = ref(null)
const editEquipmentId = ref()
const editEquipmentName = ref()
const editEquipmentQuantity = ref()
const editEquipmentDetail = ref("")
const editEquipmentDayLimit = ref()
const editEquipmentImage = ref([])

const equipmentNameRules = {
    required: (value) => !!value || "กรุณากรอกชื่ออุปกรณ์",
};
const equipmentQuantityRules = {
    required: (value) => !!value || "กรุณากรอกจำนวนอุปกรณ์",
};
const equipmentDayLimitRules = {
    required: (value) => !!value || "กรุณากรอกจำนวนวันในการยืม",
};
const isFormValid = computed(() => {
    return equipmentName.value && equipmentQuantity.value && dayLimit.value >= 1
})
const isEditFormValid = computed(() => {
    return editEquipmentName.value && editEquipmentQuantity.value && editEquipmentDayLimit.value >= 1
})

async function openDialog(equipment) {
    selectedEquipment.value = { ...equipment }
    editEquipmentId.value = selectedEquipment.value.raw.id
    editEquipmentName.value = selectedEquipment.value.raw.name
    editEquipmentQuantity.value = selectedEquipment.value.raw.quantity
    editEquipmentDetail.value = selectedEquipment.value.raw.detail
    editEquipmentDayLimit.value = selectedEquipment.value.raw.day_limit
}

async function onEditEquipment() {
    if (editEquipmentImage && editEquipmentImage.value.length > 0) {
        const formData = new FormData();
        formData.append('data', JSON.stringify({
            name: editEquipmentName.value,
            quantity: editEquipmentQuantity.value,
            day_limit: editEquipmentDayLimit.value,
            detail: editEquipmentDetail.value,
        }));
        formData.append('files.image', editEquipmentImage.value[0]);

        await axios.put(`${url}/equipments/${editEquipmentId.value}`, {
            data: {
                image: null
            }
        }, {
            headers: {
                'Authorization': `Bearer ${token.value}`,
            },
        });

        await axios.put(`${url}/equipments/${editEquipmentId.value}`, formData, {
            headers: {
                'Authorization': `Bearer ${token.value}`,
            },
        });
        getEquipments();

    } else {
        const formData = new FormData();
        formData.append('data', JSON.stringify({
            name: editEquipmentName.value,
            quantity: editEquipmentQuantity.value,
            day_limit: editEquipmentDayLimit.value,
            detail: editEquipmentDetail.value ? editEquipmentDetail.value : "",
        }));

        await axios.put(`${url}/equipments/${editEquipmentId.value}`, formData, {
            headers: {
                'Authorization': `Bearer ${token.value}`,
            },
        });
        getEquipments();
    }
}

async function onDeleteEquipment() {
    var provider = await axios.get(`${url}/users/me`, {
        params: {
            fields: {
                1: 'prefix',
                2: 'firstname',
                3: 'lastname',
            },
            populate: {
                department: {
                    fields: {
                        4: 'id'
                    }
                }
            },
        },
        headers: {
            Authorization: `Bearer ${token.value}`,
        },
    });

    var requests = await axios.get(`${url}/requests`, {
        params: {
            filters: {
                department: provider.data.department.id,
            },
            populate: {
                equipment: {
                    fields: {
                        0: 'id'
                    }
                }
            }
        },
        headers: {
            Authorization: `Bearer ${token.value}`,
        },
    })
    console.log("Request : ", requests)

    let found = false;

    if (requests.data.data.length > 0) {
        for (const request of requests.data.data) {
            if (request.attributes.equipment.data.id === editEquipmentId.value) {
                found = true;
                break;
            }
        }

        if (found) {
            warning.value = true;
            setTimeout(() => (warning.value = false), 3000);
        } else {
            try {
                await axios.delete(`${url}/equipments/${editEquipmentId.value}`, {
                    headers: {
                        'Authorization': `Bearer ${token.value}`,
                    },
                });
                getEquipments();
            } catch (error) {
                console.log(error);
            }
        }
    } else {
        console.log("No Request");
    }
}

async function onAddEquipment() {
    try {
        var provider = await axios.get(`${url}/users/me`, {
            params: {
                fields: {
                    1: 'prefix',
                    2: 'firstname',
                    3: 'lastname',
                },
                populate: {
                    department: {
                        fields: {
                            4: 'id'
                        }
                    }
                },
            },
            headers: {
                Authorization: `Bearer ${token.value}`,
            },
        });

        // console.log("Provider Name", provider.data.prefix + provider.data.firstname + " " + provider.data.lastname);
        // console.log("Department ID", provider.data.department.id);
        // console.log("Image", image.value[0]);
        // console.log("Name", equipmentName.value);
        // console.log("Quantity", equipmentQuantity.value);

        const formData = new FormData();
        formData.append('data', JSON.stringify({
            name: equipmentName.value,
            quantity: equipmentQuantity.value,
            day_limit: dayLimit.value,
            provider_name: provider.data.prefix + provider.data.firstname + " " + provider.data.lastname,
            detail: equipmentDetail.value,
            department: provider.data.department.id,
        }));
        formData.append('files.image', image.value[0]);

        const response = await axios.post(`${url}/equipments`, formData, {
            headers: {
                'Authorization': `Bearer ${token.value}`,
            },
        });

        console.log("Response After Create", response.data);

        getEquipments();
        image.value = [];
        equipmentName.value = '';
        equipmentQuantity.value = '';
        dayLimit.value = '';
        equipmentDetail.value = '';
    } catch (error) {
        console.error("Error while adding equipment:", error);
    }
}

async function onCancel() {
    image.value = []
    equipmentName.value = ''
    equipmentQuantity.value = ''
}

async function getEquipments() {
    try {
        await axios.get(`${url}/users/me`, {
            params: {
                fields: {
                    0: 'id'
                },
                populate: {
                    department: {
                        fields: {
                            1: 'id',
                        },
                        populate: {
                            equipments: {
                                fields: {
                                    2: 'id',
                                    3: 'name',
                                    4: 'quantity',
                                    5: 'day_limit',
                                    6: 'provider_name',
                                    7: 'detail'
                                },
                                populate: {
                                    image: {
                                        fields: {
                                            8: 'url',
                                        }
                                    }
                                }
                            }
                        }
                    },
                },
            },
            headers: {
                'Authorization': `Bearer ${token.value}`,
            },
        }).then((response) => {
            equipments.value = [...response.data.department.equipments]

            if (equipments.value) {
                equipmentsRef.value = equipments.value.reverse();
            } else {
                equipmentsRef.value = [];
            }

            loaded.value = true
        });
    } catch (error) {
        console.log('Error fetching equipment data:', error)
    }
}

onMounted(async () => {
    await getEquipments();
})
</script>

<style scoped>
@import url(../assets/css/styles/home.css);

.bg-gray {
    background-color: #ececec;
}

.link {
  text-decoration: none;
  color: black;
}
</style>
